#version 150

#moj_import <purple_border_gui/util_functions.glsl>
#moj_import <purple_border_gui/text_colours.glsl>
#moj_import <fog.glsl>

in vec3 Position;
in vec4 Color;
in vec2 UV0;
in ivec2 UV2;

uniform sampler2D Sampler2;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform int FogShape;

out float vertexDistance;
out vec4 vertexColor;
out vec2 texCoord0;

bool inGUI(mat4 projectionMat) {
    return projectionMat[2][3] == 0.0;
}
int toint(vec3 col) {
  ivec3 icol = ivec3(col*255);
  return (icol.r << 16) + (icol.g << 8) + icol.b;
}

void main() {
    vec3 pos = Position;
    vertexDistance = fog_distance(Position, FogShape);

    vec4 vertCol = Color;
    // experience text
    if(inGUI(ProjMat)) {
        switch ( toint(vertCol.rgb) ) {
            case 0x80ff20:
                vertCol.rgb = XP_TEXT_MAIN_COLOUR;
                break;
            case 0x203f08:
                vertCol.rgb = XP_TEXT_SHADOW_COLOUR;
                break;
            case 0x407f10:
                vertCol.rgb = XP_TEXT_MAIN_COLOUR;
                vertCol.rgb *= 0.7;
                break;
            case 0x101f04:
                vertCol.rgb = XP_TEXT_SHADOW_COLOUR;
                vertCol.rgb *= 0.7;
                break;
            case 0x404040:
                vertCol.rgb = INVENTORY_TITLE_TEXT_COLOUR;
                break;
            // next 3 are to offset text in enchantment table buttons
            case 0x685e4a:
                pos.y += 2;
                break;
            case 0xffff80:
                pos.y += 1;
                break;
            case 0x342f25:
                pos.y += 2;
                break;
        }
    }

    vertexColor = vertCol;
    gl_Position = ProjMat * ModelViewMat * vec4(pos, 1.0);
    texCoord0 = UV0;
}
